#include "defines.h"
#include "interrupt.h"
#include "serial.h"
#include "stub.h"
#include "lib.h"

int main(void)
{
  INTR_DISABLE; /* ̵ˤ */

#ifdef SIMULATOR
  extern int bss_start, ebss;

  memset(&bss_start, 0, (long)&ebss - (long)&bss_start);

  /* եȥߥ٥ */
  softvec_init();

  /* ꥢν */
  serial_init(SERIAL_DEFAULT_DEVICE);
#endif

  set_debug_traps();
  force_break();

#if 1
  puts("Hello World!\n");
#endif

#if 0
  INTR_ENABLE; /* ͭˤ */
#endif
  while (1) {
    asm volatile ("sleep"); /* ϥ⡼ɤ˰ܹ */
  }

  return 0;
}
